'''
clamav module, version 0.2

(c) 2003 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
                                                                                
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

'''

from avlib import *
import socket,re,string

def clamscan(stream,scanner):
    pf=popen(scanner+['-'])
    pf.write(fromhdr())
    pf.write(stream)
    pf.close(1)
    pf.wait()
    ret=[]
    for line in pf.readlines():
      print line
      ret.append(line)
    pf.close(2)
    if ret==[]:
      vir=''
    else:
      l=re.search(": (.*) FOUND",string.rstrip(ret[0]))
      if l:
        vir=l.group(1)
      else:
        vir="unknownerror"
    return vir,ret

def clamscanf(file,scanner):
    pf=popen(scanner+[file])
    ret=[]
    pf.wait()
    for line in pf.readlines():
      ret.append(line)
    pf.close()
    if ret==[]:
      vir=''
    else:
      l=re.search(": (.*) FOUND",string.rstrip(ret[0]))
      if l:
        vir=l.group(1)
      else:
        vir="unknownerror"
    return vir,ret

def clamd(stream,scanner):
    if scanner[1]==0: # local socket
      s=socket.socket(socket.AF_UNIX,socket.SOCK_STREAM)
      s.connect(scanner[0])
    else:
      s=socket.socket(socket.AF_INET,socket.SOCK_STREAM)
      s.connect((scanner[0],scanner[1]))
    f=s.makefile('rw',4096)
    s.send("STREAM\n")
    l=re.search('^PORT ([0-9]*)',f.readline())
    if l:
      # Send stream
      ss=socket.socket(socket.AF_INET,socket.SOCK_STREAM)
      if scanner[1]==0: # local socket
        ss.connect(('127.0.0.1',string.atoi(l.group(1))))
      else:
        ss.connect((scanner[0],string.atoi(l.group(1))))
      ss.send(fromhdr())
      ss.send(stream)
      ss.shutdown(2)
      ss.close()
      # Read reply
      ret=[]
      for line in f.readlines():
        if not re.search(": OK$",string.rstrip(line)):
          ret.append(line)
      if ret==[]:
        vir=''
      else:
        l=re.search(": (.*) FOUND$",string.rstrip(ret[0]))
        if l:
          vir=l.group(1)
        else:
          vir="unknownerror"
      return vir,ret
    else:
      raise 'Clamscan','Protocol error'
